/*
	Copyright (C) 2010 Hans-Werner Hilse <hilse@web.de>
	See file "COPYING" for licence information.
*/
#include "vipipc.h"
#include "vipipc_prototypes.h"

IPCPROTO_NEW_GENERIC(NameService, "IToiNameService")
IPCPROTO_NEW_CALL(NameService, LookupObject, "SP|ES")


IPCPROTO_NEW_SERVICE(InformationService, "InformationService", "IToiInformationService")
IPCPROTO_NEW_CALL(InformationService, GetObject, "SP|ES")
IPCPROTO_NEW_CALL(InformationService, SetObject, "SSiP|E")
IPCPROTO_NEW_CALL(InformationService, UnsetObject, "SiP|E")
IPCPROTO_NEW_CALL(InformationService, SubscribeObject, "SiSP|E")
IPCPROTO_NEW_CALL(InformationService, SubscribeObjectInternal, "SSP|E")


IPCPROTO_NEW_SERVER(InformationObserver, "IToiInformationObserver")
IPCPROTO_NEW_PARSER(InformationObserver, OnObjectsChanged, "iS")
IPCPROTO_NEW_DISPATCHER(InformationObserver, OnObjectsChanged)
IPCPROTO_NEW_PARSER(InformationObserver, OnObjectsRemoved, "iS")
IPCPROTO_NEW_DISPATCHER(InformationObserver, OnObjectsRemoved)


IPCPROTO_NEW_SERVICE(ApplicationService, "ApplicationService", "IToiApplicationService")
IPCPROTO_NEW_CALL(ApplicationService, RegisterApplication, "SP|E")
IPCPROTO_NEW_CALL(ApplicationService, ReportStarted, "iSP|E")
IPCPROTO_NEW_CALL(ApplicationService, ReportPing, "ip!")
IPCPROTO_NEW_CALL(ApplicationService, Activate, "iP!")
IPCPROTO_NEW_CALL(ApplicationService, Kill, "iP!")


IPCPROTO_NEW_SERVER(Application, "IToiApplication")
IPCPROTO_NEW_PARSER(Application, LoadUri, "SSB")
IPCPROTO_NEW_DISPATCHER(Application, LoadUri)
IPCPROTO_NEW_PARSER(Application, ChangeState, "i")
IPCPROTO_NEW_DISPATCHER(Application, ChangeState)
IPCPROTO_NEW_DISPATCHER(Application, Ping)


IPCPROTO_NEW_SERVICE(UriLoaderService, "UriLoaderService", "IToiUriLoaderService")
IPCPROTO_NEW_CALL(UriLoaderService, LoadUri, "SSP|E")


IPCPROTO_NEW_SERVICE(VolumeService, "VolumeService", "IToiVolumeService")
IPCPROTO_NEW_CALL(VolumeService, GetVolume, "P|Ei")
IPCPROTO_NEW_CALL(VolumeService, SetVolume, "iP|E")
IPCPROTO_NEW_CALL(VolumeService, IsMuted, "P|Eb")
IPCPROTO_NEW_CALL(VolumeService, Mute, "bP|E")


IPCPROTO_NEW_SERVICE(MediaService, "MediaService", "IToiMediaService")
IPCPROTO_NEW_CALL(MediaService, CreatePlayerInstance, "iSP|E")
IPCPROTO_NEW_CALL(MediaService, GetActivePlayerStatusInterface, "iSP|E")


IPCPROTO_NEW_SERVER(MediaPlayerObserver, "IToiMediaPlayerObserver")
IPCPROTO_NEW_SERVER(MediaPlayerObserverBase, "IToiMediaPlayerObserverBase")
IPCPROTO_NEW_PARSER(MediaPlayerObserver, OnMediaPlayerInitialized, "S")
IPCPROTO_NEW_DISPATCHER(MediaPlayerObserver, OnMediaPlayerInitialized)
IPCPROTO_NEW_PARSER(MediaPlayerObserverBase, OnStateChanged, "Si")
IPCPROTO_NEW_DISPATCHER(MediaPlayerObserverBase, OnStateChanged)
IPCPROTO_NEW_PARSER(MediaPlayerObserverBase, OnPositionChanged, "ii")
IPCPROTO_NEW_DISPATCHER(MediaPlayerObserverBase, OnPositionChanged)
IPCPROTO_NEW_PARSER(MediaPlayerObserverBase, OnDataAvailable, "b")
IPCPROTO_NEW_DISPATCHER(MediaPlayerObserverBase, OnDataAvailable)
IPCPROTO_NEW_DISPATCHER(MediaPlayerObserverBase, OnStreamInfoChanged)
IPCPROTO_NEW_PARSER(MediaPlayerObserverBase, OnAudioStreamInfoChanged, "ii")
IPCPROTO_NEW_DISPATCHER(MediaPlayerObserverBase, OnAudioStreamInfoChanged)
IPCPROTO_NEW_PARSER(MediaPlayerObserverBase, OnActiveAudioStreamChanged, "ii")
IPCPROTO_NEW_DISPATCHER(MediaPlayerObserverBase, OnActiveAudioStreamChanged)
IPCPROTO_NEW_PARSER(MediaPlayerObserverBase, OnVideoStreamInfoChanged, "ii")
IPCPROTO_NEW_DISPATCHER(MediaPlayerObserverBase, OnVideoStreamInfoChanged)
IPCPROTO_NEW_PARSER(MediaPlayerObserverBase, OnActiveVideoStreamChanged, "ii")
IPCPROTO_NEW_DISPATCHER(MediaPlayerObserverBase, OnActiveVideoStreamChanged)
IPCPROTO_NEW_PARSER(MediaPlayerObserverBase, OnSubtitleStreamInfoChanged, "ii")
IPCPROTO_NEW_DISPATCHER(MediaPlayerObserverBase, OnSubtitleStreamInfoChanged)
IPCPROTO_NEW_PARSER(MediaPlayerObserverBase, OnActiveSubtitleStreamChanged, "ii")
IPCPROTO_NEW_DISPATCHER(MediaPlayerObserverBase, OnActiveSubtitleStreamChanged)
IPCPROTO_NEW_PARSER(MediaPlayerObserverBase, OnTeletextStreamInfoChanged, "ii")
IPCPROTO_NEW_DISPATCHER(MediaPlayerObserverBase, OnTeletextStreamInfoChanged)
IPCPROTO_NEW_PARSER(MediaPlayerObserverBase, OnActiveTeletextStreamChanged, "ii")
IPCPROTO_NEW_DISPATCHER(MediaPlayerObserverBase, OnActiveTeletextStreamChanged)


IPCPROTO_NEW_GENERIC(MediaPlayer, "IToiMediaPlayer")
IPCPROTO_NEW_CALL(MediaPlayer, Activate, "P|E")
IPCPROTO_NEW_CALL(MediaPlayer, Open, "SP|E")
IPCPROTO_NEW_CALL(MediaPlayer, Play, "P|E")
IPCPROTO_NEW_CALL(MediaPlayer, Pause, "P|E")
IPCPROTO_NEW_CALL(MediaPlayer, Rewind, "P|E")
IPCPROTO_NEW_CALL(MediaPlayer, FastForward, "P|E")
IPCPROTO_NEW_CALL(MediaPlayer, Close, "P|E")
IPCPROTO_NEW_CALL(MediaPlayer, ReleaseInstance, "P|E")
IPCPROTO_NEW_CALL(MediaPlayer, SetActiveAudioStream, "iP|E")
IPCPROTO_NEW_CALL(MediaPlayer, SetActiveVideoStream, "iP|E")
IPCPROTO_NEW_CALL(MediaPlayer, SetActiveSubtitleStream, "iP|E")
IPCPROTO_NEW_CALL(MediaPlayer, SetActiveTeletextStream, "iP|E")
IPCPROTO_NEW_CALL(MediaPlayer, SetMacrovision, "bP|E")


IPCPROTO_NEW_GENERIC(MediaPlayerStatus, "IToiMediaPlayerStatus")
IPCPROTO_NEW_CALL(MediaPlayerStatus, GetPosition, "P|Ei") /* unsure */
IPCPROTO_NEW_CALL(MediaPlayerStatus, GetCapabilities, "P|Ei")
IPCPROTO_NEW_CALL(MediaPlayerStatus, GetState, "P|Ei")
IPCPROTO_NEW_CALL(MediaPlayerStatus, GetUrl, "P|ES")
IPCPROTO_NEW_CALL(MediaPlayerStatus, GetMacrovision, "P|Eb")
IPCPROTO_NEW_CALL(MediaPlayerStatus, GetActiveVideoStream, "P|Ei")
IPCPROTO_NEW_CALL(MediaPlayerStatus, GetActiveAudioStream, "P|Ei")
IPCPROTO_NEW_CALL(MediaPlayerStatus, GetActiveSubtitleStream, "P|Ei")
IPCPROTO_NEW_CALL(MediaPlayerStatus, GetActiveTeletextStream, "P|Ei")
IPCPROTO_NEW_CALL(MediaPlayerStatus, GetStreamInfo, "P|EM") /* unsure */
IPCPROTO_NEW_CALL(MediaPlayerStatus, GetAudioStreamInfo, "iP|EM") /* unsure */
IPCPROTO_NEW_CALL(MediaPlayerStatus, GetVideoStreamInfo, "iP|EM") /* unsure */
IPCPROTO_NEW_CALL(MediaPlayerStatus, GetSubtitleStreamInfo, "iP|EM") /* unsure */
IPCPROTO_NEW_CALL(MediaPlayerStatus, GetTeletextStreamInfo, "iP|EM") /* unsure */
IPCPROTO_NEW_CALL(MediaPlayerStatus, GetParameter, "SP|ES") /* unsure */


IPCPROTO_NEW_SERVICE(VideoMixerService, "VideoMixerService", "IToiVideoMixerService")
IPCPROTO_NEW_CALL(VideoMixerService, GetInstance, "iP|ES")


IPCPROTO_NEW_GENERIC(VideoMixer, "IToiVideoMixer")
IPCPROTO_NEW_CALL(VideoMixer, SetVideoWindow, "iiiiP|E")
IPCPROTO_NEW_CALL(VideoMixer, SetFullVideoWindow, "P|E")
IPCPROTO_NEW_CALL(VideoMixer, EnableVideoWindow, "bP|E")
IPCPROTO_NEW_CALL(VideoMixer, SetVideoFrame, "iiiiP|E")
IPCPROTO_NEW_CALL(VideoMixer, SetFullVideoFrame, "P|E")
IPCPROTO_NEW_CALL(VideoMixer, SetAlphaWindowColorKeyMode, "iiP|E")
IPCPROTO_NEW_CALL(VideoMixer, SetAlphaWindowPosition, "iiiiiP|E")
IPCPROTO_NEW_CALL(VideoMixer, SetAlphaWindowSolidColor, "iiP|E")
IPCPROTO_NEW_CALL(VideoMixer, SetAlphaWindowTransparency, "iiP|E")
IPCPROTO_NEW_CALL(VideoMixer, EnableAlphaWindow, "ibP|E")
IPCPROTO_NEW_CALL(VideoMixer, SetColorKey, "iP|E")
IPCPROTO_NEW_CALL(VideoMixer, EnableWideScreen, "bP|E")

